From beb140a875a09446933610df8d87b3079f1923ca Mon Sep 17 00:00:00 2001
From: derekriemer <derek.riemer@colorado.edu>
Date: Sun, 13 Jul 2014 17:09:53 -0600
Subject: [PATCH] fix menu losing focus bug.

---
 source/appModules/audacity.py | 17 +++++++++++++++++
 1 file changed, 17 insertions(+)

diff --git a/source/appModules/audacity.py b/source/appModules/audacity.py
index 3dfbfd7..4288c64 100644
--- a/source/appModules/audacity.py
+++ b/source/appModules/audacity.py
@@ -13,3 +13,20 @@ class AppModule(appModuleHandler.AppModule):
 	def event_NVDAObject_init(self,obj):
 		if obj.windowClassName=="Button" and not obj.role in [controlTypes.ROLE_MENUBAR, controlTypes.ROLE_MENUITEM, controlTypes.ROLE_POPUPMENU]:
 			obj.name=winUser.getWindowText(obj.windowHandle).replace('&','')
+
+	def script_menuLoseFocus(self,gesture):
+		#audacity menus don't lose focus when escape is pressed, which causes problems when a recording happens later.
+		#So make the track table gain focus.
+		focus=api.getFocusObject()
+		if focus.role==controlTypes.ROLE_MENUITEM:
+			#move the focus up and over a level. and then decend to where we need to be.
+			focus=focus.parent.next.children[1].firstChild #traverse the object hierarchy and get at the correct object.
+			#give the track view table focus like it should have.
+			eventHandler.executeEvent("gainFocus", focus)
+		gesture.send()
+
+	__gestures={
+		"kb:escape" : "menuLoseFocus",
+	}
+
+
-- 
1.8.1.msysgit.1

